<?php

namespace AppBundle\Repository\Api;

use AppBundle\Entity\Api\Citizen;
use function PHPSTORM_META\type;
use Symfony\Bundle\SecurityBundle\SecurityBundle;
use AppBundle\Object\CandidateSearch;

/**
 * CitizenRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class CitizenRepository extends \Doctrine\ORM\EntityRepository
{
    protected function addCategory($qb, $category)
    {
        if($category == 'ensemble') {
            $qb->andWhere('c.ensemble = :category')
                ->setParameter('category', true);
        } elseif($category == 'department') {
            $qb->andWhere('c.department = :category')
                ->setParameter('category', true);
        } else {
            $qb->andWhere('c.senat = :category')
                ->setParameter('category', true);
        }
    }

    public function queryAll($category = 'senat')
    {
        $qb = $this->createQueryBuilder('c');

        $this->addCategory($qb, $category);
        $qb->orderBy('c.createdAt', 'DESC');

        return $qb;
    }

    public function queryMembers($category = 'senat')
    {
        $qb = $this->createQueryBuilder('c');
//        $qb->andWhere('c.pub = :public')
//            ->setParameter('public', true);
        $qb->andWhere('c.active = :active')
            ->setParameter('active', true);
        $qb->andWhere('c.support = :support')
            ->setParameter('support', true);
        $this->addCategory($qb, $category);
        $qb->orderBy('c.city', 'ASC')
            ->addOrderBy('c.createdAt', 'DESC');

        return $qb;
    }

    public function queryAllMembers($category = 'senat')
    {
        $qb = $this->createQueryBuilder('c');
        $qb->select('count(c.id)');
        $qb->andWhere('c.active = :active')
            ->setParameter('active', true);
        $qb->andWhere('c.support = :support')
            ->setParameter('support', true);
        $this->addCategory($qb, $category);
        return $qb;
    }
}
